clc
%#ok<*UNRCH>  for unreached lines

Fs = 3e6;  % Hz
lineTime = 0.025;
inputFileName = "images/mathworks.jpg";

%% Generate IQ stream
iqstream = single(img2iqstream(inputFileName, Fs, lineTime));
frameSize = 2^16;
frames = floor(length(iqstream)/frameSize);
data = reshape(iqstream(1:frames*frameSize),frameSize,frames);

%% Create Spectrum Analyzer Scope
sa = dsp.SpectrumAnalyzer(...
  "ViewType","Spectrogram", ...
  "TimeSpanSource","Property", ...
  "TimeSpan", 240, ...
  "ReducePlotRate", false, ...
  "ColorLimits", [-80 20]);
%sa.setDebugLevel(1);
sa.show()

%% Set up radio
useRadio = false;
if useRadio
  txPluto = sdrtx("Pluto", ...
    "BasebandSampleRate",Fs)
  rxPluto = sdrrx("Pluto", ...
    "BasebandSampleRate",Fs, ...
    "OutputDataType","single", ...
    "SamplesPerFrame",frameSize)
else  % nothing to do
end

%% Plot the spectrogram.  Optionally use the radio.
repeats = 10;
for k=1:repeats
  if useRadio
    for frame = 1:frames  
      txPluto(data(:,frame));
      rxData = rxPluto();
      sa(rxData);
    end
  else  % no radio
    for frame = 1:frames
      sa(data(:,frame))
    end
  end
end
